package com.drht.datamanage.handler;

import com.drht.datamanage.util.AnalysisUtil;
import com.drht.datamanage.cache.CommandInitCache;
import com.drht.datamanage.service.Reply;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.SimpleChannelInboundHandler;
import io.netty.util.internal.logging.InternalLogger;
import io.netty.util.internal.logging.InternalLoggerFactory;

import java.io.IOException;

public class ReplyDeviceInChannelHandler extends SimpleChannelInboundHandler {
    private static final InternalLogger logger = InternalLoggerFactory.getInstance(ReplyDeviceInChannelHandler.class);
    // 检查完设备后，回复命令调用
    @Override
    public void channelRead0(ChannelHandlerContext ctx, Object msg) throws Exception {
        AnalysisUtil.Msg msgo= (AnalysisUtil.Msg) msg;
        //根据cn分别回复
        String cn = msgo.getCN();
        //根据cn获取执行对象
        Reply reply = CommandInitCache.getReplyCache().get(cn);
        //执行业务逻辑
        reply.rese(msgo,ctx);
//        ctx.fireChannelRead(msg);
    }

    // 数据读取完后被调用
    @Override
    public void channelReadComplete(ChannelHandlerContext ctx) throws Exception {
        ctx.flush();
    }

    // 当Netty由于IO错误或者处理器在处理事件时抛出的异常时被调用
    @Override
    public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) throws Exception {
        if (cause instanceof IOException){
            logger.error("io异常");
            ctx.close();
            return;
        }
        cause.printStackTrace();
        ctx.close();
    }
}
